<script setup lang="ts">
import { computed, nextTick, ref, watchEffect } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Salary } from '@/types/Salary'
import { useSalarysStore } from '@/stores/salary'
import { useAuthStore } from '@/stores/auth'
import { useHistoryStore } from '@/stores/history'

const headers = [
  {
    title: 'Id',
    key: 'id'
  },
  {
    title: 'name',
    key: 'name'
  },
  {
    title: 'Email',
    key: 'email'
  },
  {
    title: 'Salary',
    key: 'salary'
  },
  {
    title: 'Date',
    key: 'date'
  },
  {
    title: 'UserID',
    key: 'userId'
  },
  {
    title: 'CheckIn',
    key: 'historyCheckin',
    value: (item: any | Salary) => (item.historyCheckin ? item.historyCheckin.length : 0),
    width: '100px'
  },
  {
    title: 'CheckOut',
    key: 'historyCheckout',
    value: (item: any | Salary) => (item.historyCheckout ? item.historyCheckout.length : 0),
    width: '100px'
  },
  { title: 'Actions', key: 'actions', sortable: false },
  { title: 'Pay Salary', key: 'paysalary', sortable: false },
  { title: 'Paystatus', key: 'paystatus', sortable: false }
]
const salaryStore = useSalarysStore()
const authStore = useAuthStore()
const historyStore = useHistoryStore()
let editedIndex = -1
const editedSalarys = ref<Salary>(JSON.parse(JSON.stringify(salaryStore.defaultsalary)))
const salarys = ref<Salary[]>([])
salarys.value = salaryStore.salarys
const Paystatus = ref<boolean>(false)
const dialogCheckHistory = ref(false)
const dialog = ref(false)
const dialogDelete = ref(false)
const dialogPaysalary = ref(false)
const confirmPayId = ref(0)
const dialogPaysalarywaspaid1 = ref(false)
const form = ref(false)
const loading = ref(false)
const refform = ref<VForm | null>(null)

let lastestId = 1
let latestId = 1

salarys.value.forEach((salary) => {
  if (salary.id > lastestId) {
    latestId = salary.id
  }
})
lastestId = latestId + 1

function editItem(item: Salary) {
  editedIndex = salarys.value.indexOf(item)
  editedSalarys.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: Salary) {
  editedIndex = salarys.value.indexOf(item)
  editedSalarys.value = Object.assign({}, item)
  dialogDelete.value = true
}

function deleteItemConfirm() {
  salarys.value.splice(editedIndex, 1)
  closeDelete()
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedSalarys.value = Object.assign({}, salaryStore.defaultsalary)
  })
  editedIndex = -1
}

function onSubmit() {}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedSalarys.value = Object.assign({}, salaryStore.defaultsalary)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(salarys.value[editedIndex], editedSalarys.value)
  } else {
    editedSalarys.value.id = lastestId++
    editedSalarys.value.status = false
    const userId = editedSalarys.value.userId
    const currentUser = userId !== null ? authStore.users.find((user) => user.id === userId) : null
    if (currentUser) {
      editedSalarys.value.name = currentUser.fullname || ''
      editedSalarys.value.email = currentUser.email || ''

      const userHistory = {
        historyCheckin: historyStore.historyCheckIn.filter(
          (checkIn) => checkIn.user?.id === currentUser.id
        ),
        historyCheckout: historyStore.historyCheckOut.filter(
          (checkOut) => checkOut.user?.id === currentUser.id
        )
      }

      Object.assign(editedSalarys.value, currentUser, userHistory)
      salarys.value.push(editedSalarys.value)
    } else {
      console.log(editedSalarys.value.id)
      console.log(currentUser)
    }
  }

  closeDialog()
}

function paySalaryConfirmation(item: Salary) {
  confirmPayId.value = item.id
  dialogPaysalary.value = true
}
function closesalaryDialog() {
  dialogPaysalary.value = false
}
function closesalarywaspaidDialog() {
  closesalaryDialog()
  if (editedSalarys.value.status) {
    Paystatus.value = true
  }
  dialogPaysalarywaspaid1.value = false
}
function Confirmpaysalary() {
  const salaryIndex = salarys.value.findIndex((salary) => salary.id === confirmPayId.value)
  if (salaryIndex !== -1) {
    salarys.value[salaryIndex].status = true
    salaryStore.Paystatus = true
  }
  dialogPaysalarywaspaid1.value = true
  updatePayStatus(editedSalarys.value)
}
function updatePayStatus(item: Salary) {
  item.status = true
}

const updatedSalarys = computed(() => salaryStore.salarys)
watchEffect(() => {
  salarys.value = updatedSalarys.value
})
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="salarys" style="background-color: white">
      <template v-slot:top>
        <v-toolbar flat style="background-color: #212121; color: white">
          <v-toolbar-title>Salary</v-toolbar-title>
          <v-dialog v-model="dialog" persistent width="500">
            <template v-slot:activator="{ props }">
              <v-btn v-bind="props" style="background-color: #c7a17a; color: white">
                New Salary
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Salary</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model="editedSalarys.salary"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Salary"
                          placeholder="Enter Member Salary"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model.number="editedSalarys.userId"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="User Id"
                          placeholder="Enter User Id"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model.number="editedSalarys.date"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Date"
                          placeholder="Enter Date"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small style="color: red">*Please fill data</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" v-model="dialog" @click="editItem(item)"
          >mdi-pencil</v-icon
        >
        <v-icon size="small" v-model="dialogDelete" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:[`item.paysalary`]="{ item }">
        <v-icon
          size="large"
          v-model="dialogPaysalary"
          @click="paySalaryConfirmation(item)"
          :color="'orange yellow'"
          >mdi-currency-usd</v-icon
        >
      </template>
      <template v-slot:[`item.paystatus`]="{ item }">
        <v-icon
          :icon="item.status ? 'mdi-checkbox-marked-circle' : 'mdi-cancel'"
          :color="item.status ? 'green' : 'red'"
          end
        ></v-icon>
      </template>
    </v-data-table>
  </div>
  <v-dialog v-model="dialogPaysalary" max-width="500px">
    <v-card>
      <v-card-title class="text-h5">Are you sure you want to pay salary</v-card-title>
      <v-card-actions>
        <v-spacer></v-spacer>
        <template> </template>
        <v-btn color="primary" variant="text" @click="closesalaryDialog()">Cancel</v-btn>
        <v-btn color="primary" variant="text" @click="Confirmpaysalary()">OK</v-btn>
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
  <v-dialog v-model="dialogPaysalarywaspaid1" max-width="500px">
    <v-card>
      <v-card-title class="text-h5">Salary was paid ^^ </v-card-title>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="primary" variant="text" @click="closesalarywaspaidDialog()">OK</v-btn>
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
  <v-dialog v-model="dialogDelete" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        All values associated with this field will be lost.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div style="margin: 0 auto; max-width: 400px">
          <v-btn
            block
            style="background-color: #e11d48"
            color="white"
            variant="text"
            @click="deleteItemConfirm()"
          >
            Delete field
          </v-btn>
        </div>
      </div>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>
</template>
<style scoped></style>
